acia_baud	equ	$E645
acia_control	equ	$E646
acia_data	equ	$E647

crtaddr		equ	$e600
crtdata		equ	$e601

tempa		equ	$80
tempb		equ	$81
tempx		equ	$82

	org	$100
	
	jmp	start

sio_irq
	ldab	acia_control	; 
	tba
	anda	#%00000001	;
	beq	noread		;
	ldaa	acia_data
	staa	recvchar
	andb	#%01110000
	beq	noread
	clr	recvchar
	bitb	#%01000000
	beq	noerr1
	ldx	#errPE
	jsr	putStr
noerr1	bitb	#%00100000
	beq	noerr2
	ldx	#errOVRN
	jsr	putStr
noerr2	bitb	#%00010000
	beq	noread
	ldx	#errFE
	jsr	putStr
noread	rts

errPE	db	10,'SIO Parity Error!',0
errOVRN	db	10,'SIO OverRun Error!',0
errFE	db	10,'SIO Frame Error!',0

initScr
	ldx	#$f000
	stx	curSadr
	stx	scrAdr
inits1	clr	0,x
	inx
	cpx	#$f400
	bne	inits1
	clr	curX
	clr	curY
	ldx	#25*42
	stx	scrSize
	rts
	
putChar
	staa	tempa
	stab	tempb
	stx	tempx
	cmpa	#' '
	bcs	putctrlchar
putch
	ldx	curSadr
	staa	0,x
	inx
	stx	curSadr
	jsr	fuckPut
	inc	curX
	ldaa	curX
	cmpa	#40
	bne	putcharend
putLF
	ldaa	#40
	ldab	curSadr
	suba	curX
	adda	#$2
	adda	curSadr+1
	adcb	#0
	staa	curSadr+1
	stab	curSadr
	clr	curX
putCR
	inc	curY
	ldaa	curY
	cmpa	#26
	bne	putcharend
	dec	curY
	jsr	hardScroll
	bra	putcharend
putctrlchar
	cmpa	#$0c
	bne	noputctrL
	jsr	initScr
	bra	putcharend
noputctrL
	cmpa	#$0A
	beq	putLF
	cmpa	#$0D
	bne	noputCR
	ldaa	curSadr+1
	ldab	curSadr
	adda	#42
	adcb	#0
	staa	curSadr+1
	stab	curSadr
	bra	putCR
noputCR
	bra	putch
putcharend	
	ldx	tempx
	ldab	tempb
	ldaa	tempa
	rts

fuckPut
	psha
	ldaa	curSadr+1
	ldab	curSadr
	suba	scrSize+1
	sbcb	scrSize
	suba	#42
	sbcb	#0
	cmpb	#$f0
	bne	fuck1
	staa	altScr+1
	stab	altScr
	pula
	ldx	altScr
	staa	0,x
	rts
fuck1	pula
	rts
	
	
hardScroll
	ldaa	scrAdr+1
	ldab	scrAdr
	adda	#42		;fix hardware bug of 2 us delay
	adcb	#0
	staa	scrAdr+1
	stab	scrAdr
	ldx	curSadr
	cpx	#
	bne	hardS1
	ldx	#$f000
	stx	curSadr
	stx	scrAdr
hardS1
	psha
	ldaa	#42
hardS2	clr	0,x
	inx
	deca
	bne	hardS2
	tba
	ldab	#12
	bsr	set_6845
	incb
	pula
set_6845 jmp	set6845

set6845
	stab	crtaddr
	staa	crtdata
	rts
	
putStr	
	psha
putst1	ldaa	0,x
	beq	putst2
	jsr	putChar
	inx
	bra	putst1
putst2	pula
	rts

initSio
	ldab	#%00000011	; init SIO
	stab	acia_control	;

	ldab	#%00000101	; set baud 4800
	stab	acia_baud	; not SIO, specific Pyldin reg
	ldab	#%11010001	; rie, 8 bit, 2 stop, 1:16f
	stab	acia_control	; set SIO
	rts

start
	jsr	initScr
	ldx	#logo1
	jsr	putStr

dddd	int	$20
	jsr	putChar
	bra	dddd
	
	ldaa	#$03
	int	$2e
	stab	oldirqp
	stx	oldirqa

	ldab	#0
	ldaa	#$03
	ldx	#sio_irq
	int	$2f

	jsr	initSio

mainLoop
	ldaa	recvchar
	beq	mainLoop
	clr	recvchar
	jsr	putChar
	bra	mainLoop


	ldab	#%00000001	; 
read1
	bitb	acia_control	;
	bne	read2		; 
	int	$10
	inca
	bne	sendChar
	bra	read1
read2
	ldaa	acia_data	;
	int	$22		; 
	bra	mainLoop

sendChar
	int	$20
	cmpa	#$c0
	bne	s1
	ldaa	#$0a
s1
	int	$22
	ldab	#%00000010	; 
write1
	bitb	acia_control
	bne	write1		; 
	staa	acia_data	; 

	bra	mainLoop

logo1
	db	10,10,10,'Welcome to SIO microterminal!',10,10,10,0

recvchar db	0

scrAdr	dw	0
curSadr	dw	0
scrSize	dw	0
altScr	dw	0
curX	db	0
curY	db	0

oldirqp	db	0
oldirqa	dw	0

    dw	$f000, $f02a, $f054, $f07e, $f0a8, $f0d2, $f0fc, $f126, $f150, $f17a
    dw	$f1a4, $f1ce, $f1f8, $f222, $f24c, $f276, $f2a0, $f2ca, $f2f4, $f31e
    dw	$f348, $f372, $f39c, $f3c6, $f3f0, $f41a, $f444, $f46e, $f498, $f4c2
    dw	$f4ec, $f516, $f540, $f56a, $f594, $f5be, $f5e8, $f612, $f63c, $f666
    dw	$f690, $f6ba, $f6e4, $f70e, $f738, $f762, $f78c, $f7b6, $f7e0, $f80a
    dw	$f834, $f85e, $f888, $f8b2, $f8dc, $f906, $f930, $f95a, $f984, $f9ae
    dw	$f9d8, $fa02, $fa2c, $fa56, $fa80, $faaa, $fad4, $fafe, $fb28, $fb52
    dw	$fb7c, $fba6, $fbd0, $fbfa, $fc24, $fc4e, $fc78, $fca2, $fccc, $fcf6
