acia_baud	equ	$E645
acia_control	equ	$E646
acia_data	equ	$E647

crtaddr 	equ	$E600
crtdata 	equ	$E601

synchro_addr	equ	$ED04
PUTCHAR		equ	$FA16

	org	$100
	
	jmp	start

PUTSTR
	ldaa	0,x
	beq	PUTSTR1
	stx	tempx
	jsr	PUTCHAR
	ldx	tempx
	inx
	bra	PUTSTR
PUTSTR1 cli
	rts

sio_irq
	ldab	acia_control	; 
	tba
	anda	#%00000001	;
	beq	noread		;
	ldaa	acia_data
	ldx	rbufptr
	staa	0,x
	inx
	cpx	#rbufend
	bne	sio_0
	ldx	#rbuf
sio_0	stx	rbufptr
	andb	#%01110000
	beq	noread
	stx	recvchar
	bitb	#%01000000
	beq	noerr1
	ldx	#errPE
	jsr	PUTSTR
noerr1	bitb	#%00100000
	beq	noerr2
	ldx	#errOVRN
	jsr	PUTSTR
noerr2	bitb	#%00010000
	beq	noread
	ldx	#errFE
	jsr	PUTSTR
noread	rts

errPE	db	10,'SIO Parity Error!',0
errOVRN	db	10,'SIO OverRun Error!',0
errFE	db	10,'SIO Frame Error!',0

initSio
	ldab	#%00000011	; init SIO
	stab	acia_control	;

	ldab	#%00000100	; set baud 2400
	stab	acia_baud	; not SIO, specific Pyldin reg
	ldab	#%11010001	; rie, 8 bit, 2 stop, 1:16f
	stab	acia_control	; set SIO
	ldx	#rbuf
	stx	rbufptr
	stx	recvchar
	rts

start
	ldx	#logo1
	jsr	PUTSTR

	ldaa	#$03
	int	$2e
	stab	oldirqp
	stx	oldirqa

	ldab	#0
	ldaa	#$03
	ldx	#sio_irq
	int	$2f

	jsr	initSio

mainLoop
	ldx	recvchar
main0	cpx	rbufptr
	beq	mainLoop
	ldaa	$0,x
	inx
	cpx	#rbufend
	bne	main1
	ldx	#rbuf
main1	stx	recvchar
	jsr	PUTCHAR
	cli
	bra	mainLoop


	ldab	#%00000001	; 
read1
	bitb	acia_control	;
	bne	read2		; 
	int	$10
	inca
	bne	sendChar
	bra	read1
read2
	ldaa	acia_data	;
	int	$22		; 
	bra	mainLoop

sendChar
	int	$20
	cmpa	#$c0
	bne	s1
	ldaa	#$0a
s1
	int	$22
	ldab	#%00000010	; 
write1
	bitb	acia_control
	bne	write1		; 
	staa	acia_data	; 

	bra	mainLoop

logo1
	db	10,10,10,'Welcome to SIO microterminal!',10,10,10,0

recvchar dw	0

rbufptr	dw	0
rbuf	ds	128,0
rbufend

tempx	dw	0

oldirqp	db	0
oldirqa	dw	0
